import 'package:flutter/material.dart';
import 'package:medapay/entity.dart';
import 'package:medapay/medapay.dart';

void main() {
  runApp(MyApp());
}

class MyApp extends StatelessWidget {
  // This widget is the root of your application.
  @override
  Widget build(BuildContext context) {
    return MaterialApp(
      title: 'MedaPay SDK Demo',
      theme: ThemeData(
        primarySwatch: Colors.orange,
        visualDensity: VisualDensity.adaptivePlatformDensity,
      ),
      home: MyHomePage(title: 'MedaPay SDK Demo Home Page'),
    );
  }
}

class MyHomePage extends StatefulWidget {
  MyHomePage({Key key, this.title}) : super(key: key);

  final String title;

  @override
  _MyHomePageState createState() => _MyHomePageState();
}

class _MyHomePageState extends State<MyHomePage> {
  int _counter = 0;

  MedaPayLauncher launcher = MedaPayLauncher(apiKey: "xxxx", isSandbox: true);

  void onReferenceNumber(String referenceNumber) {
    print("Reference Number: " + referenceNumber);
  }

  void onSuccess(String successData) {
    print("Success Data: " + successData);
  }

  void onError(String error) {
    print("Error: " + error);
  }

  void _initPayment(context) {
    launcher.init(
        context: context,
        payment: new MedaPayPayment(
            customerName: "Ayele Mekite",
            accountNumber: "251913008595",
            description: "Flutter SDK Demo Payment",
            amount: 0.5),
        onReferenceNumber: onReferenceNumber,
        onSuccess: onSuccess,
        onError: onError);
  }

  @override
  Widget build(BuildContext context) {
    return Scaffold(
      appBar: AppBar(
        title: Text(widget.title),
      ),
      body: Center(
          child: Column(
              mainAxisAlignment: MainAxisAlignment.center,
              children: <Widget>[
            RaisedButton(
                onPressed: () {
                  _initPayment(context);
                },
                child: const Text('Launch Test Payment')),
          ])),
      // This trailing comma makes auto-formatting nicer for build methods.
    );
  }
}
